package twi

import (
	"courseSign/server/global"
    "courseSign/server/model/twi"
    "courseSign/server/model/common/request"
    twiReq "courseSign/server/model/twi/request"
    "courseSign/server/model/common/response"
    "courseSign/server/service"
    "github.com/gin-gonic/gin"
    "go.uber.org/zap"
    "courseSign/server/utils"
)

type TwiProjectApi struct {
}

var twiProjectService = service.ServiceGroupApp.TwiServiceGroup.TwiProjectService


// CreateTwiProject 创建TwiProject
// @Tags TwiProject
// @Summary 创建TwiProject
// @Security ApiKeyAuth
// @accept application/json
// @Produce application/json
// @Param data body twi.TwiProject true "创建TwiProject"
// @Success 200 {string} string "{"success":true,"data":{},"msg":"获取成功"}"
// @Router /twiProject/createTwiProject [post]
func (twiProjectApi *TwiProjectApi) CreateTwiProject(c *gin.Context) {
	var twiProject twi.TwiProject
	err := c.ShouldBindJSON(&twiProject)
	if err != nil {
		response.FailWithMessage(err.Error(), c)
		return
	}
    verify := utils.Rules{
        "ProjectName":{utils.NotEmpty()},
        "Banner":{utils.NotEmpty()},
    }
	if err := utils.Verify(twiProject, verify); err != nil {
    		response.FailWithMessage(err.Error(), c)
    		return
    	}
	if err := twiProjectService.CreateTwiProject(twiProject); err != nil {
        global.GVA_LOG.Error("创建失败!", zap.Error(err))
		response.FailWithMessage("创建失败", c)
	} else {
		response.OkWithMessage("创建成功", c)
	}
}

// DeleteTwiProject 删除TwiProject
// @Tags TwiProject
// @Summary 删除TwiProject
// @Security ApiKeyAuth
// @accept application/json
// @Produce application/json
// @Param data body twi.TwiProject true "删除TwiProject"
// @Success 200 {string} string "{"success":true,"data":{},"msg":"删除成功"}"
// @Router /twiProject/deleteTwiProject [delete]
func (twiProjectApi *TwiProjectApi) DeleteTwiProject(c *gin.Context) {
	var twiProject twi.TwiProject
	err := c.ShouldBindJSON(&twiProject)
	if err != nil {
		response.FailWithMessage(err.Error(), c)
		return
	}
	if err := twiProjectService.DeleteTwiProject(twiProject); err != nil {
        global.GVA_LOG.Error("删除失败!", zap.Error(err))
		response.FailWithMessage("删除失败", c)
	} else {
		response.OkWithMessage("删除成功", c)
	}
}

// DeleteTwiProjectByIds 批量删除TwiProject
// @Tags TwiProject
// @Summary 批量删除TwiProject
// @Security ApiKeyAuth
// @accept application/json
// @Produce application/json
// @Param data body request.IdsReq true "批量删除TwiProject"
// @Success 200 {string} string "{"success":true,"data":{},"msg":"批量删除成功"}"
// @Router /twiProject/deleteTwiProjectByIds [delete]
func (twiProjectApi *TwiProjectApi) DeleteTwiProjectByIds(c *gin.Context) {
	var IDS request.IdsReq
    err := c.ShouldBindJSON(&IDS)
	if err != nil {
		response.FailWithMessage(err.Error(), c)
		return
	}
	if err := twiProjectService.DeleteTwiProjectByIds(IDS); err != nil {
        global.GVA_LOG.Error("批量删除失败!", zap.Error(err))
		response.FailWithMessage("批量删除失败", c)
	} else {
		response.OkWithMessage("批量删除成功", c)
	}
}

// UpdateTwiProject 更新TwiProject
// @Tags TwiProject
// @Summary 更新TwiProject
// @Security ApiKeyAuth
// @accept application/json
// @Produce application/json
// @Param data body twi.TwiProject true "更新TwiProject"
// @Success 200 {string} string "{"success":true,"data":{},"msg":"更新成功"}"
// @Router /twiProject/updateTwiProject [put]
func (twiProjectApi *TwiProjectApi) UpdateTwiProject(c *gin.Context) {
	var twiProject twi.TwiProject
	err := c.ShouldBindJSON(&twiProject)
	if err != nil {
		response.FailWithMessage(err.Error(), c)
		return
	}
      verify := utils.Rules{
          "ProjectName":{utils.NotEmpty()},
          "Banner":{utils.NotEmpty()},
      }
    if err := utils.Verify(twiProject, verify); err != nil {
      	response.FailWithMessage(err.Error(), c)
      	return
     }
	if err := twiProjectService.UpdateTwiProject(twiProject); err != nil {
        global.GVA_LOG.Error("更新失败!", zap.Error(err))
		response.FailWithMessage("更新失败", c)
	} else {
		response.OkWithMessage("更新成功", c)
	}
}

// FindTwiProject 用id查询TwiProject
// @Tags TwiProject
// @Summary 用id查询TwiProject
// @Security ApiKeyAuth
// @accept application/json
// @Produce application/json
// @Param data query twi.TwiProject true "用id查询TwiProject"
// @Success 200 {string} string "{"success":true,"data":{},"msg":"查询成功"}"
// @Router /twiProject/findTwiProject [get]
func (twiProjectApi *TwiProjectApi) FindTwiProject(c *gin.Context) {
	var twiProject twi.TwiProject
	err := c.ShouldBindQuery(&twiProject)
	if err != nil {
		response.FailWithMessage(err.Error(), c)
		return
	}
	if retwiProject, err := twiProjectService.GetTwiProject(twiProject.ID); err != nil {
        global.GVA_LOG.Error("查询失败!", zap.Error(err))
		response.FailWithMessage("查询失败", c)
	} else {
		response.OkWithData(gin.H{"retwiProject": retwiProject}, c)
	}
}

// GetTwiProjectList 分页获取TwiProject列表
// @Tags TwiProject
// @Summary 分页获取TwiProject列表
// @Security ApiKeyAuth
// @accept application/json
// @Produce application/json
// @Param data query twiReq.TwiProjectSearch true "分页获取TwiProject列表"
// @Success 200 {string} string "{"success":true,"data":{},"msg":"获取成功"}"
// @Router /twiProject/getTwiProjectList [get]
func (twiProjectApi *TwiProjectApi) GetTwiProjectList(c *gin.Context) {
	var pageInfo twiReq.TwiProjectSearch
	err := c.ShouldBindQuery(&pageInfo)
	if err != nil {
		response.FailWithMessage(err.Error(), c)
		return
	}
	if list, total, err := twiProjectService.GetTwiProjectInfoList(pageInfo); err != nil {
	    global.GVA_LOG.Error("获取失败!", zap.Error(err))
        response.FailWithMessage("获取失败", c)
    } else {
        response.OkWithDetailed(response.PageResult{
            List:     list,
            Total:    total,
            Page:     pageInfo.Page,
            PageSize: pageInfo.PageSize,
        }, "获取成功", c)
    }
}
